# CVS $Id: ImportPreChecker.py,v 1.1.1.1 2006/02/26 15:54:20 jay Exp $
#=========================================================================
# Main object for the Import pre checks.
# 
#  Copyright (C) 2006 Jay van der Meer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#=========================================================================
import string

class ImportPreChecker:
	"""
		This class will run an initial check on a obj file. The number of materials actually used will be
		counted.
	"""
	def __init__(self,FullPathOBJFile,FullPathCollapseFile):
		
		self.MyOBJFileFN = FullPathOBJFile
		self.MyCollapseFile = FullPathCollapseFile
		self.UsedMaterialHash = {}
		self.MTLLibFN = None
		
	def CheckMaterialLimit(self):
		"""
			Count the number of actual materials used and return the count.
		"""
		matcnt = -1
		MyOBJFile = file(self.MyOBJFileFN,'r')
		
		for TheLine in MyOBJFile.readlines():
			CleanLine = TheLine.replace('\t',' ')
			CleanLine = string.strip(CleanLine,'\r\n')
			WorkLine = string.split(CleanLine)
			
			if len(WorkLine) == 0:
				continue
			
			if WorkLine[0] == "#":
				continue

			if WorkLine[0].startswith("mtllib") == True:
				self.MTLLibFN = WorkLine[1]
				continue

			if WorkLine[0] == 'usemtl':
				MyCurrentMaterialName = WorkLine[1]
				
				if self.UsedMaterialHash.__contains__(MyCurrentMaterialName) == False:
					matcnt = matcnt + 1
					self.UsedMaterialHash[MyCurrentMaterialName] = matcnt
					print("Uses unique material name %s") % MyCurrentMaterialName
					
		MyOBJFile.close()
		
		return matcnt