# CVS $Id: MTLContainer.py,v 1.1.1.1 2006/02/26 15:54:20 jay Exp $
#=========================================================================
# Utility class to hold information about the .mtl sections.
# 
#  Copyright (C) 2006 Jay van der Meer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#=========================================================================
class MTLContainer:
	"""
		A container object that holds the content section of the .mtl file.
		Each section is all the lines up to the next material name. It is used
		by MTLReWriter class.
		
		Material name, type and file name of the image are stored, along with 
		the actual data lines from the file.
	"""
	def __init__(self):
		self.MaterialName = None
		self.MaterialType = None
		self.ImageName = None
		self.MTLFileLines = []
