import Blender

def import_obj(path):
	Blender.Window.WaitCursor(1)

	# parse the file
	file = open(path, 'r')

	scn = Blender.Scene.GetCurrent()
	for o in scn.getChildren():
		o.sel = 0

	name = 'dummy'
	object_pending = 0
	verts_in_object = 0
	linenr = 0
	v_off = 0
	facelist = []
	vertexlist = []

	for line in file.readlines():
		linenr = linenr + 1
		words = line.split()
		if len(words) == 0 or words[0].startswith('#'):
			pass
		elif words[0] == 'g' or words[0] == 'o':
			# new group or object (we treat it the same)
			print 'new group in line %i' % linenr
			object_pending = 1
			name = words[1];
			
		elif words[0] == 'v':
			if object_pending == 1:
				# save the previous object
				mesh.verts.extend(vertexlist)
				mesh.faces.extend(facelist)
				ob = Blender.Object.New('Mesh', name)
				ob.link(mesh)
				scn.link(ob)
				ob.sel= 1
				ob.Layers = scn.Layers
				v_off += verts_in_object
				verts_in_object = 0
				object_pending = 0
				facelist = []
				vertexlist = []

			# is this vertex the first one in the object?
			if verts_in_object == 0:
				# create a new Mesh
				mesh = Blender.Mesh.New()
				print 'creating a new mesh in line %i' % linenr
				
			vertexlist.append([float(words[1]), float(words[2]), float(words[3])])
			verts_in_object = verts_in_object + 1

		elif words[0] == 'f':
			faceVertList = []
			for faceIdx in words[1:]:
				# Poser uses vertex / texture vertex / normal vertex
				faceIdx = faceIdx.split('/')[0]
				faceVertList.append(int(faceIdx)-1 - v_off)
			facelist.append(faceVertList)
	
	if object_pending == 1:
		# save the previous object
		mesh.verts.extend(vertexlist)
		mesh.faces.extend(facelist)
		ob = Blender.Object.New('Mesh', name)
		ob.link(mesh)
		scn.link(ob)
		ob.sel= 1
		ob.Layers = scn.Layers

	Blender.Window.WaitCursor(0)
	Blender.Window.RedrawAll()

Blender.Window.FileSelector(import_obj, 'Import')
