# CVS $Id: posermtimport.py,v 1.1.1.1 2006/02/26 15:54:20 jay Exp $
#=========================================================================
# A script to run inside of blender that will import an object intended to be a morph target.
#
#  Copyright (C) 2006 Jay van der Meer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#=========================================================================
import Blender
import os
from FaceImporter import *

def importposer_mt(ThePath):
	""" Read a obj file format that is expected to be a poser morph target. A single exported object from poser with no
		world translations.
	"""
	ablank = " "
	VTLines = []
	Blender.Window.WaitCursor(1)
	MyPath,MyFN = os.path.split(ThePath)
	MeshName = string.split(MyFN,".")
	print("Creating mesh name %s") % MeshName[0]
	MyMesh = Blender.NMesh.New(MeshName[0])
    
	MyFile = open(ThePath,'r',4096)
    
	MyFaceIMP = FaceImporter()
	MyFaceIMP.VTList = VTLines
	
	for MyLine in MyFile.readlines():
		
		TheWords = MyLine.split()
		if len(TheWords) == 0:
			continue
					
		if TheWords[0].startswith("#"):
			continue
						
		if TheWords[0] == 'v':
			x = float(TheWords[1])
			y = float(TheWords[2])
			z = float(TheWords[3])
			MyMesh.verts.append(Blender.NMesh.Vert(x,y,z))
			continue
			
		if TheWords[0] == "vt":
			vt1 = float(TheWords[1])
			vt2 = float(TheWords[2])
			VTLines.append((vt1,vt2))
			continue
					
		if TheWords[0] == 'f':
			NewFace = MyFaceIMP.ProcessFaceRecordMT(TheWords,MyMesh)
			MyMesh.addFace(NewFace)
			
	MyFile.close()
	
	MyObj = Blender.Object.New('Mesh')
	MyObj.name = MeshName[0] + "_M"
	MyObj.link(MyMesh)
	MyScene = Blender.Scene.GetCurrent()
	
	for o in MyScene.getChildren():
		o.sel = 0
		
	MyScene.link(MyObj)
	MyObj.sel = 1
	MyObj.Layers = MyScene.Layers
	
	Blender.Window.WaitCursor(0)
	Blender.Window.RedrawAll()
	
# Ask blender to give us a file selector window then run the script.
Blender.Window.FileSelector(importposer_mt,'Import')
	